//#**************************************************************
//#
//# filename:             FE2DTriQuad.cpp
//#
//# author:               Gerstmayr Johannes, YV
//#
//# generated:						December 2010
//# description:          2D particular finite elements
//#                       
//# remarks:						  
//#
//# Copyright (c) 2003-2018 Johannes Gerstmayr, Linz Center of Mechatronics GmbH, Austrian
//# Center of Competence in Mechatronics GmbH, Institute of Technical Mechanics at the 
//# Johannes Kepler Universitaet Linz, Austria. All rights reserved.
//#
//# This file is part of HotInt.
//# HotInt is free software: you can redistribute it and/or modify it under the terms of 
//# the HOTINT license. See folder 'licenses' for more details.
//#
//# bug reports are welcome!!!
//# WWW:		www.hotint.org
//# email:	bug_reports@hotint.org or support@hotint.org
//#***************************************************************************************
#include "finiteElement2D.h"
#include "Material.h"
#include "node.h"
#include "rigid2d.h"
#include "renderContext.h"

#include "solversettings_auto.h"
#include "femathhelperfunctions.h"
#include "fe2dtriquad.h"
#include "options_class_auto.h"

//void Quadrilateral::SetQuadrilateral(int bodyindi, const TArray<int>& nodelist, int material_num, double thickness, const Vector3D& coli)
//{
//	assert(nodelist.Length() == 4 || nodelist.Length() == 9);		// Quadrilateral, number of nodes in the set function is invalid
//	FiniteElement2D::SetFiniteElement2D(bodyindi, nodelist, material_num, thickness, coli);
//	SetGeometricNonlinearityStatus(GNS_Linear);
//}
//
//double Quadrilateral::GetS0(const Vector2D& ploc, int shape) const
//{
//	// nodes are always sorted counterclock-wise in x-y (r-s) plane
//	double r = ploc.X();
//	double s = ploc.Y();
//
//	if(NNodes() == 4)
//	{
//		switch(shape)
//		{
//		case 1:	return 0.25*(1+r)*(1+s);
//		case 2:	return 0.25*(1-r)*(1+s);
//		case 3:	return 0.25*(1-r)*(1-s);
//		case 4:	return 0.25*(1+r)*(1-s);
//		}
//	}
//	else
//	{
//		double r2 = r*r;
//		double s2 = s*s;
//
//		switch(shape)
//		{
//		case 1: return  r*s/4.0+r2*s/4.0+r2*s2/4.0+s2*r/4.0;
//		case 2: return  -r*s/4.0+r2*s/4.0+r2*s2/4.0-s2*r/4.0;
//		case 3: return  r*s/4.0-s2*r/4.0+r2*s2/4.0-r2*s/4.0;
//		case 4: return  -r*s/4.0-r2*s/4.0+r2*s2/4.0+s2*r/4.0;
//		case 5: return  s/2.0-r2*s/2.0+s2/2.0-r2*s2/2.0;
//		case 6: return  -r/2.0+s2*r/2.0+r2/2.0-r2*s2/2.0;
//		case 7: return  -s/2.0+r2*s/2.0+s2/2.0-r2*s2/2.0;
//		case 8: return  r/2.0-s2*r/2.0+r2/2.0-r2*s2/2.0;
//		case 9: return  (-1.0+r2)*(-1.0+s2);
//		}
//	}
//	assert(0);
//	return 0;
//}
//
//void Quadrilateral::GetDSMatrix0(const Vector2D& ploc, Matrix& sf) const
//{
//	double r = ploc.X();
//	double s = ploc.Y();
//
//	if(NNodes() == 4)
//	{
//		sf.SetSize(Dim(),NS());
//
//		//D_sf/D_r :
//		sf(1,1) = 0.25*(1+s);  //Node 1
//		sf(1,2) =-0.25*(1+s);  //Node 2
//		sf(1,3) =-0.25*(1-s);  //Node 3
//		sf(1,4) = 0.25*(1-s);  //Node 4
//
//		//D_sf/D_s :
//		sf(2,1) = 0.25*(1+r);  //Node 1
//		sf(2,2) = 0.25*(1-r);  //Node 2
//		sf(2,3) =-0.25*(1-r);  //Node 3
//		sf(2,4) =-0.25*(1+r);  //Node 4
//	}
//	else
//	{
//		double r2 = r*r;
//		double s2 = s*s;
//
//		//D_sf/D_r:
//		sf(1,1) =  s/4.0+r*s/2.0+s2*r/2.0+s2/4.0;
//		sf(1,2) =  -s/4.0+r*s/2.0+s2*r/2.0-s2/4.0;
//		sf(1,3) =  s/4.0-s2/4.0+s2*r/2.0-r*s/2.0;
//		sf(1,4) =  -s/4.0-r*s/2.0+s2*r/2.0+s2/4.0;
//		sf(1,5) =  -r*s-s2*r;
//		sf(1,6) =  -1.0/2.0+s2/2.0+r-s2*r;
//		sf(1,7) =  r*s-s2*r;
//		sf(1,8) =  1.0/2.0-s2/2.0+r-s2*r;
//		sf(1,9) =  2.0*r*(-1.0+s2);
//
//		//D_sf/D_s:
//		sf(2,1) =  r/4.0+r2/4.0+r2*s/2.0+r*s/2.0;
//		sf(2,2) =  -r/4.0+r2/4.0+r2*s/2.0-r*s/2.0;
//		sf(2,3) =  r/4.0-r*s/2.0+r2*s/2.0-r2/4.0;
//		sf(2,4) =  -r/4.0-r2/4.0+r2*s/2.0+r*s/2.0;
//		sf(2,5) =  1.0/2.0-r2/2.0+s-r2*s;
//		sf(2,6) =  r*s-r2*s;
//		sf(2,7) =  -1.0/2.0+r2/2.0+s-r2*s;
//		sf(2,8) =  -r*s-r2*s;
//		sf(2,9) =  2.0*(-1.0+r2)*s;
//	}
//}
//
//Vector2D Quadrilateral::GetNodeLocPos2D(int i) const
//{
//	switch(i)
//	{ //1..4 for linear element, 1..9 for quadratic element
//	case 1: return Vector2D( 1., 1.); break;
//	case 2: return Vector2D(-1., 1.); break;
//	case 3: return Vector2D(-1.,-1.); break;
//	case 4: return Vector2D( 1.,-1.); break;
//	case 5: return Vector2D( 0., 1.); break;
//	case 6: return Vector2D(-1., 0.); break;
//	case 7: return Vector2D( 0.,-1.); break;
//	case 8: return Vector2D( 1., 0.); break;
//	case 9: return Vector2D( 0., 0.); break;
//	default: return Vector2D(0,0);
//	}
//}
//
//int Quadrilateral::GetActualInterpolationOrder() const
//{
//	switch(NNodes())
//	{
//	case 4: return 2;
//	case 9: return 4;
//	}
//	assert(0);
//	return 0;
//}
//
//void Quadrilateral::DefineIntegrationRule(IntegrationRule & integrationRule)
//{
//	assert(integrationRule.settings.elementType == TFE_Quadrilateral);
//
//	int ruleOrder = 0;
//	// here the particular rule order will be chosen depending on the settings
//	if(
//		integrationRule.settings.interpolationOrder == 2 ||
//		integrationRule.settings.integratedValueType == IntegrationRule::IVT_Load
//		)
//		ruleOrder = 2;
//	else
//	{
//		if(integrationRule.settings.integratedValueType == IntegrationRule::IVT_Stiffness)
//			ruleOrder = 4;
//		else
//			ruleOrder = 3;
//		if(integrationRule.settings.geometricNonlinearityStatus == GNS_NonlinearLargeStrain)
//			ruleOrder++;
//	}
//	assert(ruleOrder != 0);
//
//	IntegrationRule::DefineIntegrationRuleSquare(integrationRule, ruleOrder);
//}
//





//class QuadrilateralGeneric ... redefined by $EK 2015-07-14
//4 and 8 noded (element) ... 9 noded quadratic element neglected
template<class FiniteElement2DBase>
void QuadrilateralGeneric<FiniteElement2DBase>::SetQuadrilateralGeneric(int bodyindi, const TArray<int>& nodelist, int material_num, double thickness, const Vector3D& coli)
{
	assert(nodelist.Length() == 4 || nodelist.Length() == 8 || nodelist.Length() == 9);		// Quadrilateral, number of nodes in the set function is invalid
	FiniteElement2DBase::SetFiniteElement2D(bodyindi, nodelist, material_num, thickness, coli);
	SetGeometricNonlinearityStatus(GNS_Linear);
}

template<class FiniteElement2DBase>
double QuadrilateralGeneric<FiniteElement2DBase>::GetS0(const Vector2D& ploc, int shape) const
{
	//order of nodes:
	//          
	// y     2 +------+ 1     
	// ^       |      | 
	// |       |      |
	// |       |      |
	// --->X 3 +------+ 4     
	//

	// nodes are always sorted counterclock-wise in x-y (r-s) plane
	double r = ploc.X();
	double s = ploc.Y();

	if (NNodes() == 4)
	{
		switch(shape)
		{	
		case 1:	return 0.25*(1+r)*(1+s);
		case 2:	return 0.25*(1-r)*(1+s);
		case 3:	return 0.25*(1-r)*(1-s);
		case 4:	return 0.25*(1+r)*(1-s);			
		}
	}
	else if (NNodes() == 8)
	{

	//order of nodes:
	//            5
	// y     2 +--+--+ 1     
	// ^       |     | 
	// |     6 +     + 8
	// |       |     |
	// --->X 3 +--+--+ 4     
	//            7

		double r2 = r*r;
		double s2 = s*s;

		switch(shape)
		{
		case 1: return (1.0+r)*(1.0+s)*(r+s-1.0)/4.0; break;
		case 2: return (1.0-r)*(1.0+s)*(-r+s-1.0)/4.0; break;
		case 3: return (1.0-r)*(1.0-s)*(-r-s-1.0)/4.0; break;
		case 4: return (1.0+r)*(1.0-s)*(r-s-1.0)/4.0; break;
		case 5: return (1.0-r*r)*(1.0+s)/2.0; break;
		case 6: return (1.0-s*s)*(1.0-r)/2.0; break;
		case 7: return (1.0-r*r)*(1.0-s)/2.0; break;
		case 8: return (1.0-s*s)*(1.0+r)/2.0; break;
		}
	}
	else // NNodes() == 9
	{
		// Z
		// | Y     2 +---5---+ 1
		// |/     6 /   9   / 8
		// --->X 3 +---7---+ 4     
		//
		double r2 = r*r;
		double s2 = s*s;

		switch(shape)
		{
		case 1: return  r*s/4.0+r2*s/4.0+r2*s2/4.0+s2*r/4.0;
		case 2: return  -r*s/4.0+r2*s/4.0+r2*s2/4.0-s2*r/4.0;
		case 3: return  r*s/4.0-s2*r/4.0+r2*s2/4.0-r2*s/4.0;
		case 4: return  -r*s/4.0-r2*s/4.0+r2*s2/4.0+s2*r/4.0;
		case 5: return  s/2.0-r2*s/2.0+s2/2.0-r2*s2/2.0;
		case 6: return  -r/2.0+s2*r/2.0+r2/2.0-r2*s2/2.0;
		case 7: return  -s/2.0+r2*s/2.0+s2/2.0-r2*s2/2.0;
		case 8: return  r/2.0-s2*r/2.0+r2/2.0-r2*s2/2.0;
		case 9: return  (-1.0+r2)*(-1.0+s2);
		}
	}
	assert(0);
	return 0;
}

template<class FiniteElement2DBase>
void QuadrilateralGeneric<FiniteElement2DBase>::GetDSMatrix0(const Vector2D& ploc, Matrix& sf) const
{
	double r = ploc.X();
	double s = ploc.Y();
	sf.SetSize(Dim(),NS());

	if(NNodes() == 4)
	{
		sf(1,1) = (1.0+s)/4.0;
		sf(1,2) = -(1.0+s)/4.0;
		sf(1,3) = -(1.0-s)/4.0;
		sf(1,4) = (1.0-s)/4.0;
		sf(2,1) = (1.0+r)/4.0;
		sf(2,2) = (1.0-r)/4.0;
		sf(2,3) = -(1.0-r)/4.0;
		sf(2,4) = -(1.0+r)/4.0;
	}
	else if (NNodes() == 8)
	{
		sf(1,1) =  r*(0.5 + 0.5*s) + (0.25 + 0.25*s)*s;
		sf(1,2) =  r*(0.5 + 0.5*s) + (-0.25 - 0.25*s)*s;
		sf(1,3) =  r*(0.5 - 0.5*s) + (0.25 - 0.25*s)*s;
		sf(1,4) =  r*(0.5 - 0.5*s) + (-0.25 + 0.25*s)*s;
		sf(1,5) = -r*(1.0+s);
		sf(1,6) =  (-1.0+s*s)/2.0;  
		sf(1,7) =  r*(s-1.0);
		sf(1,8) =  (1.0-s*s)/2.0;
		sf(2,1) =  r*( 0.25 + 0.25*r + 0.5*s) + 0.5*s;
		sf(2,2) =  r*(-0.25 + 0.25*r - 0.5*s) + 0.5*s;
		sf(2,3) =  r*( 0.25 - 0.25*r - 0.5*s) + 0.5*s;
		sf(2,4) =  r*(-0.25 - 0.25*r + 0.5*s) + 0.5*s;
		sf(2,5) = (1.0-r*r)/2.0;
		sf(2,6) = -s*(1.0-r);
		sf(2,7) = (-1.0+r*r)/2.0;
		sf(2,8) = -s*(1.0+r);
	}
	else
	{
		double r2 = r*r;
		double s2 = s*s;

		//D_sf/D_r:
		sf(1,1) =  s/4.0+r*s/2.0+s2*r/2.0+s2/4.0;
		sf(1,2) =  -s/4.0+r*s/2.0+s2*r/2.0-s2/4.0;
		sf(1,3) =  s/4.0-s2/4.0+s2*r/2.0-r*s/2.0;
		sf(1,4) =  -s/4.0-r*s/2.0+s2*r/2.0+s2/4.0;
		sf(1,5) =  -r*s-s2*r;
		sf(1,6) =  -1.0/2.0+s2/2.0+r-s2*r;
		sf(1,7) =  r*s-s2*r;
		sf(1,8) =  1.0/2.0-s2/2.0+r-s2*r;
		sf(1,9) =  2.0*r*(-1.0+s2);

		//D_sf/D_s:
		sf(2,1) =  r/4.0+r2/4.0+r2*s/2.0+r*s/2.0;
		sf(2,2) =  -r/4.0+r2/4.0+r2*s/2.0-r*s/2.0;
		sf(2,3) =  r/4.0-r*s/2.0+r2*s/2.0-r2/4.0;
		sf(2,4) =  -r/4.0-r2/4.0+r2*s/2.0+r*s/2.0;
		sf(2,5) =  1.0/2.0-r2/2.0+s-r2*s;
		sf(2,6) =  r*s-r2*s;
		sf(2,7) =  -1.0/2.0+r2/2.0+s-r2*s;
		sf(2,8) =  -r*s-r2*s;
		sf(2,9) =  2.0*(-1.0+r2)*s;
	}
}

template<class FiniteElement2DBase>
Vector2D QuadrilateralGeneric<FiniteElement2DBase>::GetNodeLocPos2D(int i) const
{
	//generate local node position hierarchically:
	if (NNodes() == 9)
	{
		// Z
		// | Y     2 +---5---+ 1
		// |/     6 /   9   / 8
		// --->X 3 +---7---+ 4     
		//
		switch (i)
		{
		case 3: return Vector2D(-1,-1);
		case 4: return Vector2D(1,-1);
		case 1: return Vector2D(1,1); 
		case 2: return Vector2D(-1,1);
		case 7: return Vector2D(0,-1);
		case 8: return Vector2D(1,0); 
		case 5: return Vector2D(0,1); 
		case 6: return Vector2D(-1,0);
		case 9: return Vector2D(0,0);
		}
	}
	else // NNodes() == 8 || NNodes() == 4
	{
		//order of nodes:
		//            5
		// y     2 +--+--+ 1     
		// ^       |     | 
		// |     6 +     + 8
		// |       |     |
		// --->X 3 +--+--+ 4     
		//            7
		switch (i)
		{
		case 1: return Vector2D(1,1); 
		case 2: return Vector2D(-1,1);
		case 3: return Vector2D(-1,-1);
		case 4: return Vector2D(1,-1);
		case 5: return Vector2D(0,1); 
		case 6: return Vector2D(-1,0);
		case 7: return Vector2D(0,-1);
		case 8: return Vector2D(1,0); 
		}
	}
	assert(0);
	return Vector2D(0,0);
}

template<class FiniteElement2DBase>
void QuadrilateralGeneric<FiniteElement2DBase>::DrawElement()
{
	mbs->Graphics3D()->SetColor(col);
	mbs->Graphics3D()->SetDrawOutline(1); //turn on outline drawing

	HOTINTOptions::ViewingOptionsClass* vo = GetMBS()->GetOptions()->ViewingOptions();

	int linemode = 1; //0=no lines, 1=outline+color, 2=outline, 3=elementline+color, 4=elementline
	
	if (vo->FiniteElementsMeshShow() && !vo->FiniteElementsContourActivate())
	{
		linemode = 2;
	}
	if (!vo->FiniteElementsMeshShow() && vo->FiniteElementsContourActivate())
	{
		linemode = 0;
	}

	int colormode = 0;
	const FieldVariableDescriptor * fv = GetMBS()->GetActualPostProcessingFieldVariable();
	if (fv != NULL && HasFieldVariable(*fv))
	{
		colormode = 1;
	}

	int res = GetMBS()->GetDrawResolution() - 1;
	if (colormode == 0 && NS() <= 4)
		res = 0;		// linear elements, not colored
	if (res < 0) res = 0;

	double tilex = pow(2.,res);

	double tiley = tilex;
	int tileyn = (int)tiley;

	double v = 0;

	TArray<Vector3D> points((int)(tilex+1)*(int)(tiley+1));
	TArray<double> vals((int)(tilex+1)*(int)(tiley+1));
	points.SetLen(0);
	vals.SetLen(0);

	if (vo->FiniteElementsContourPlotInterpolated())
	{
		if (NNodes() == 4)
		{
			// plotting linear element interpolated - can be done quickly
			// add rectangular grid of points and values
			points.Add(ToP3D(GetPos2DD(Vector2D(-1,-1), 1))); //3
			points.Add(ToP3D(GetPos2DD(Vector2D( 1,-1), 1))); //4
			points.Add(ToP3D(GetPos2DD(Vector2D(-1, 1), 1))); //2
			points.Add(ToP3D(GetPos2DD(Vector2D( 1, 1), 1))); //1
			vals.Add(GetNode(3).GetDrawTemp());
			vals.Add(GetNode(4).GetDrawTemp());
			vals.Add(GetNode(2).GetDrawTemp());
			vals.Add(GetNode(1).GetDrawTemp());
			mbs->Graphics3D()->DrawColorQuads(points,vals,2,2,colormode,linemode);
		}
		else if (NNodes() == 9)
		{
			double thickness = vo->FiniteElementsMeshElementLineThickness();
			bool advancedlinemode = true;

			if (advancedlinemode)
				GetMBS()->Graphics3D()->GetRC()->BeginLinesOnSolid();

			// plotting quadratic element interpolated
			points.Add(ToP3D(GetPos2DD(Vector2D( 0, 0), 1))); //9
			points.Add(ToP3D(GetPos2DD(Vector2D( 1, 0), 1))); //8
			points.Add(ToP3D(GetPos2DD(Vector2D( 0, 1), 1))); //5
			points.Add(ToP3D(GetPos2DD(Vector2D( 1, 1), 1))); //1
			vals.Add(GetNode(9).GetDrawTemp());
			vals.Add(GetNode(8).GetDrawTemp());
			vals.Add(GetNode(5).GetDrawTemp());
			vals.Add(GetNode(1).GetDrawTemp());
			if(vo->FiniteElementsContourActivate())
			{
				mbs->Graphics3D()->DrawColorQuads(points,vals,2,2,colormode,0);
			}
			if(vo->FiniteElementsMeshShow())
			{
				mbs->Graphics3D()->MyDrawLine(points(2),points(4),thickness);
				mbs->Graphics3D()->MyDrawLine(points(4),points(3),thickness);
			}

			points(1) = ToP3D(GetPos2DD(Vector2D(-1, 0), 1)); //6
			points(2) = ToP3D(GetPos2DD(Vector2D( 0, 0), 1)); //9
			points(3) = ToP3D(GetPos2DD(Vector2D(-1, 1), 1)); //2
			points(4) = ToP3D(GetPos2DD(Vector2D( 0, 1), 1)); //5
			vals(1) = GetNode(6).GetDrawTemp();
			vals(2) = GetNode(9).GetDrawTemp();
			vals(3) = GetNode(2).GetDrawTemp();
			vals(4) = GetNode(5).GetDrawTemp();
			if(vo->FiniteElementsContourActivate())
			{
				mbs->Graphics3D()->DrawColorQuads(points,vals,2,2,colormode,0);
			}
			if(vo->FiniteElementsMeshShow())
			{
				mbs->Graphics3D()->MyDrawLine(points(4),points(3),thickness);
				mbs->Graphics3D()->MyDrawLine(points(3),points(1),thickness);
			}

			points(1) = ToP3D(GetPos2DD(Vector2D(-1,-1), 1)); //3
			points(2) = ToP3D(GetPos2DD(Vector2D( 0,-1), 1)); //7
			points(3) = ToP3D(GetPos2DD(Vector2D(-1, 0), 1)); //6
			points(4) = ToP3D(GetPos2DD(Vector2D( 0, 0), 1)); //9
			vals(1) = GetNode(3).GetDrawTemp();
			vals(2) = GetNode(7).GetDrawTemp();
			vals(3) = GetNode(6).GetDrawTemp();
			vals(4) = GetNode(9).GetDrawTemp();
			if(vo->FiniteElementsContourActivate())
			{
				mbs->Graphics3D()->DrawColorQuads(points,vals,2,2,colormode,0);
			}
			if(vo->FiniteElementsMeshShow())
			{
				mbs->Graphics3D()->MyDrawLine(points(3),points(1),thickness);
				mbs->Graphics3D()->MyDrawLine(points(1),points(2),thickness);
			}

			points(1) = ToP3D(GetPos2DD(Vector2D( 0,-1), 1)); //7
			points(2) = ToP3D(GetPos2DD(Vector2D( 1,-1), 1)); //4
			points(3) = ToP3D(GetPos2DD(Vector2D( 0, 0), 1)); //9
			points(4) = ToP3D(GetPos2DD(Vector2D( 1, 0), 1)); //8
			vals(1) = GetNode(7).GetDrawTemp();
			vals(2) = GetNode(4).GetDrawTemp();
			vals(3) = GetNode(9).GetDrawTemp();
			vals(4) = GetNode(8).GetDrawTemp();
			if(vo->FiniteElementsContourActivate())
			{
				mbs->Graphics3D()->DrawColorQuads(points,vals,2,2,colormode,0);
			}
			if(vo->FiniteElementsMeshShow())
			{
				mbs->Graphics3D()->MyDrawLine(points(1),points(2),thickness);
				mbs->Graphics3D()->MyDrawLine(points(2),points(4),thickness);
			}

			if (advancedlinemode)
				GetMBS()->Graphics3D()->GetRC()->EndLinesOnSolid();
		}
	}
	else // not interpolated
	{
		// full version
		Vector2D p0, vx, vy;

		double shrink = vo->FiniteElementsMeshShrinkingFactor();//0.995;
		p0 = Vector2D(-1*shrink,-1*shrink);
		vx = Vector2D(2./tilex*shrink,0);
		vy = Vector2D(0,2./tileyn*shrink);

		for (double iy = 0; iy <= tileyn+1e-8; iy++)
		{
			for (double ix = 0; ix <= tilex+1e-8; ix++)
			{
				Vector2D ploc = p0 + ix * vx + iy * vy;
				Vector3D pg = ToP3D(GetPos2DD(ploc, 1));
				points.Add(pg);
				if (colormode)
					v = GetFieldVariableValue(*GetMBS()->GetActualPostProcessingFieldVariable(), ploc, true);
				vals.Add(v);
			}
		}
		mbs->Graphics3D()->DrawColorQuads(points,vals,(int)tilex+1,(int)tileyn+1,colormode,linemode);
	}
}





template<class FiniteElement2DBase>
const FEEdge & QuadrilateralGeneric<FiniteElement2DBase>::GetLocalEdge(int i) const
{
	static FEEdge localEdgesLinear[] = {
		FEEdge(1,2),
		FEEdge(2,3),
		FEEdge(3,4),
		FEEdge(4,1),
		FEEdge(0,0)
	};
	static FEEdge localEdgesQuadratic[] = {
		FEEdge(1,2,5),
		FEEdge(2,3,6),
		FEEdge(3,4,7),
		FEEdge(4,1,8),
		FEEdge(0,0,0)
	};
	if (i < 1 || i > 4)
	{
		assert(0 && "QuadrilateralGeneric::GetLocalEdge called with a wrong index.");
		return localEdgesLinear[4];
	}
	if (NNodes() == 4)
	{
		return localEdgesLinear[i - 1];
	}
	else //NNodes() == 8, quadratic
	{
		return localEdgesQuadratic[i - 1];
	}
}

template<class FiniteElement2DBase>
Vector2D QuadrilateralGeneric<FiniteElement2DBase>::GetEdgeNormal(int edge_nr) const
{
	assert(1 <= edge_nr && edge_nr <= 4);
	int node_1 = edge_nr;
	int node_2 = (edge_nr) % 4 + 1;
	Vector2D v = GetNodePos2D(node_2) - GetNodePos2D(node_1);
	Vector2D n(v(2), -v(1));
	n.Normalize();
	return n;
}

template<class FiniteElement2DBase>
Vector2D QuadrilateralGeneric<FiniteElement2DBase>::GetEdgeNormalD(int edge_nr) const
{
	assert(1 <= edge_nr && edge_nr <= 4);
	int node_1 = edge_nr;
	int node_2 = (edge_nr) % 4 + 1;
	Vector2D v = GetNodePos2DD(node_2) - GetNodePos2DD(node_1);
	Vector2D n(v(2), -v(1));
	n.Normalize();
	return n;
}

template<class FiniteElement2DBase>
Vector2D QuadrilateralGeneric<FiniteElement2DBase>::GetAreaCoordOfEdgeCoord(int edge, double p_loc_edge) const
{
	switch (edge)
	{
	case 1:	return Vector2D( -p_loc_edge,  1 );
	case 2:	return Vector2D( -1, -p_loc_edge );
	case 3:	return Vector2D(  p_loc_edge, -1 );
	case 4:	return Vector2D(  1,  p_loc_edge );
	}
	assert(false && "edge number must be between 1 and 4");
	return Vector2D(0, 0);
}

template<class FiniteElement2DBase>
int QuadrilateralGeneric<FiniteElement2DBase>::GetActualInterpolationOrder() const
{
	switch(NNodes())
	{
	case 4: return 2;
	case 8: return 4;
	case 9: return 4;
	}
	assert(0);
	return 0;
}

template<class FiniteElement2DBase>
void QuadrilateralGeneric<FiniteElement2DBase>::DefineIntegrationRule(IntegrationRule & integrationRule)
{
	assert(integrationRule.settings.elementType == TFE_Quadrilateral);

	int ruleOrder = DefineIntegrationRuleOrder(integrationRule);

	IntegrationRule::DefineIntegrationRuleSquare(integrationRule, ruleOrder);
}

template<class FiniteElement2DBase>
int QuadrilateralGeneric<FiniteElement2DBase>::DefineIntegrationRuleOrder(IntegrationRule & integrationRule) const
{
	assert(integrationRule.settings.elementType == TFE_Quadrilateral);

	int ruleOrder = 0;
	// here the particular rule order will be chosen depending on the settings
	if(
		integrationRule.settings.interpolationOrder == 2 ||
		integrationRule.settings.integratedValueType == IntegrationRule::IVT_Load
		)
		ruleOrder = 2;
	else
	{
		if(integrationRule.settings.integratedValueType == IntegrationRule::IVT_Stiffness)
		{
			ruleOrder = 4;
		}
		else
		{
			//$EK 2015-07-14 changed from ruleOrder = 3; since order 3 would not yield an exact integration for quadratic shape functions
			ruleOrder = 4; 
		}
		if(integrationRule.settings.geometricNonlinearityStatus == GNS_NonlinearLargeStrain)
		{	
			ruleOrder++;
		}
	}
	assert(ruleOrder != 0);

	return ruleOrder;
}



template<class FiniteElement2DBase>
vtk::vtkElementInfo QuadrilateralGeneric<FiniteElement2DBase>::GetVtkInfo() const
{
	vtk::vtkElementInfo vtk;
	vtk.nodes = nodes;
	vtk.cell_domain = materialnum;
	bool is_quadratic = (NNodes()==8);

	if (is_quadratic)
	{
		vtk.cell_Type = vtk::VTK_QUADRATIC_QUAD;
	}
	else
	{
		vtk.cell_Type = vtk::VTK_QUAD;
	}
	return vtk;
}

//$ SW 2016-11-8: Implemented Triangle Elements, old Trig2Dlin and Trig2Dquad are removed
//3 and 6 noded (element)

template<class FiniteElement2DBase>
void TriangularGeneric<FiniteElement2DBase>::SetTriangularGeneric(int bodyindi, const TArray<int>& nodelist, int material_num, double thickness, const Vector3D& coli)
{
	assert(nodelist.Length() == 3 || nodelist.Length() == 6);		// Quadrilateral, number of nodes in the set function is invalid
	FiniteElement2DBase::SetFiniteElement2D(bodyindi, nodelist, material_num, thickness, coli);
	SetGeometricNonlinearityStatus(GNS_Linear);
}

template<class FiniteElement2DBase>
double TriangularGeneric<FiniteElement2DBase>::GetS0(const Vector2D& ploc, int shape) const
{
	//order of nodes:
	//          
	// y     3 +    
	// ^       | \ 
	// |       |   \ 
	// |       |     \
	// --->X 1 +------+ 2     
	//

	// nodes are always sorted counterclock-wise in x-y (r-s) plane
	double r = ploc.X();
	double s = ploc.Y();

	if (NNodes() == 3)
	{
		switch(shape)
		{	
		case 1:	return 1-r-s;
		case 2:	return r;
		case 3:	return s;
		}
	}
	else if (NNodes() == 6)
	{

	//order of nodes:
	//           
	// y     3 +    
	// ^       | \ 
	// |     6 +   + 5 
	// |       |     \
	// --->X 1 +--+--+ 2     
	//            4

		switch(shape)
		{
		case 1:	return (1-r-s) * (1             - 2*r - 2*s);
		case 2:	return    r    * (1 - 2*(1-r-s)       - 2*s);
		case 3:	return    s    * (1 - 2*(1-r-s) - 2*r      );
		case 4: return 4*r*(1-r-s);
		case 5: return 4*r*s;
		case 6: return 4*s*(1-r-s);
		}
	}
	assert(0);
	return 0;
}

template<class FiniteElement2DBase>
void TriangularGeneric<FiniteElement2DBase>::GetDSMatrix0(const Vector2D& ploc, Matrix& sf) const
{
	double r = ploc.X();
	double s = ploc.Y();
	sf.SetSize(Dim(),NS());

	if(NNodes() == 3)
	{
		sf(1,1) = -1.;
		sf(1,2) = 1.;
		sf(1,3) = 0.;
		sf(2,1) = -1;
		sf(2,2) = 0;
		sf(2,3) = 1;
	}
	else if (NNodes() == 6)
	{
		sf(1,1) =  4*r + 4*s - 3;
		sf(1,2) =  4*r - 1;
		sf(1,3) =  0;
		sf(1,4) =  -8*r - 4*s + 4;
		sf(1,5) = 4*s;
		sf(1,6) =  -4*s;  

		sf(2,1) =  4*r + 4*s - 3;
		sf(2,2) =  0;
		sf(2,3) =  4*s - 1;
		sf(2,4) =  -4*r;
		sf(2,5) =  4*r;
		sf(2,6) =  -4*r - 8*s + 4;
	}
}

template<class FiniteElement2DBase>
Vector2D TriangularGeneric<FiniteElement2DBase>::GetNodeLocPos2D(int i) const
{

	//order of nodes:
	//           
	// y     3 +    
	// ^       | \ 
	// |     6 +   + 5 
	// |       |     \
	// --->X 1 +--+--+ 2     
	//            4

	switch (i)
	{
	case 1: return Vector2D(0,0); 
	case 2: return Vector2D(1,0);
	case 3: return Vector2D(0,1);
	case 4: return Vector2D(0.5,0);
	case 5: return Vector2D(0.5,0.5); 
	case 6: return Vector2D(0,0.5);
	}
	assert(0);
	return Vector2D(0,0);
}

template<class FiniteElement2DBase>
const FEEdge & TriangularGeneric<FiniteElement2DBase>::GetLocalEdge(int i) const
{
	static FEEdge localEdgesLinear[] = {
		FEEdge(1,2),
		FEEdge(2,3),
		FEEdge(3,1),
		FEEdge(0,0)
	};
	static FEEdge localEdgesQuadratic[] = {
		FEEdge(1,2,4),
		FEEdge(2,3,5),
		FEEdge(3,1,6),
		FEEdge(0,0,0)
	};

	if (i < 1 || i > 3)
	{
		assert(0 && "TriangularGeneric::GetLocalEdge called with a wrong index.");
		return localEdgesLinear[3];
	}
	if (NNodes() == 3)
	{
		return localEdgesLinear[i - 1];
	}
	else //NNodes() == 6, quadratic
	{
		return localEdgesQuadratic[i - 1];
	}


}

template<class FiniteElement2DBase>
Vector2D TriangularGeneric<FiniteElement2DBase>::GetEdgeNormal(int edge_nr) const
{
	assert(1 <= edge_nr && edge_nr <= 3);
	int node_1 = edge_nr;
	int node_2 = (edge_nr) % 3 + 1;
	Vector2D v = GetNodePos2D(node_2) - GetNodePos2D(node_1);
	Vector2D n(v(2), -v(1));
	n.Normalize();
	return n;
}

template<class FiniteElement2DBase>
Vector2D TriangularGeneric<FiniteElement2DBase>::GetEdgeNormalD(int edge_nr) const
{
	assert(1 <= edge_nr && edge_nr <= 3);
	int node_1 = edge_nr;
	int node_2 = (edge_nr) % 3 + 1;
	Vector2D v = GetNodePos2DD(node_2) - GetNodePos2DD(node_1);
	Vector2D n(v(2), -v(1));
	n.Normalize();
	return n;
}

template<class FiniteElement2DBase>
Vector2D TriangularGeneric<FiniteElement2DBase>::GetAreaCoordOfEdgeCoord(int edge, double p_loc_edge) const
{
	switch (edge)
	{
	case 1:	return Vector2D(0.5*(p_loc_edge+1), 0);
	case 2:	return Vector2D(0.5*(1-p_loc_edge), 0.5*(p_loc_edge + 1));
	case 3:	return Vector2D(0, 0.5*(1 - p_loc_edge));
	}
	assert(false && "edge number must be between 1 and 3");
	return Vector2D(0, 0);
}

template<class FiniteElement2DBase>
int TriangularGeneric<FiniteElement2DBase>::GetActualInterpolationOrder() const
{
	switch(NNodes())
	{
	case 3: return 1;
	case 6: return 2;
	}
	assert(0);
	return 0;
}


template<class FiniteElement2DBase>
void TriangularGeneric<FiniteElement2DBase>::DefineIntegrationRule(IntegrationRule & integrationRule)
{
	assert(integrationRule.settings.elementType == TFE_Triangle);

	int ruleOrder = DefineIntegrationRuleOrder(integrationRule);

	IntegrationRule::DefineIntegrationRuleTriangle(integrationRule, ruleOrder);
}

template<class FiniteElement2DBase>
int TriangularGeneric<FiniteElement2DBase>::DefineIntegrationRuleOrder(IntegrationRule & integrationRule) const
{
	assert(integrationRule.settings.elementType == TFE_Triangle);

	int ruleOrder = 0;
	// here the particular rule order will be chosen depending on the settings
	if (integrationRule.settings.interpolationOrder == 2 ||
		integrationRule.settings.integratedValueType == IntegrationRule::IVT_Load
		)
		ruleOrder = 2;
	else
	{
		if (integrationRule.settings.integratedValueType == IntegrationRule::IVT_Stiffness)
		{
			ruleOrder = 4;
		}
		else
		{
			//$EK 2015-07-14 changed from ruleOrder = 3; since order 3 would not yield an exact integration for quadratic shape functions
			ruleOrder = 4;
		}
		if (integrationRule.settings.geometricNonlinearityStatus == GNS_NonlinearLargeStrain)
		{
			ruleOrder++;
		}
		else if (integrationRule.settings.geometricNonlinearityStatus == GNS_Linear)
		{
			ruleOrder = 0;
		}
	}

	return ruleOrder;
}

template<class FiniteElement2DBase>
void TriangularGeneric<FiniteElement2DBase>::DrawElementPreProc()
{
	if (!GetMBS()->GetIOption(118)) return;

	FieldVariableDescriptor * fvd = GetMBS()->GetActualPostProcessingFieldVariable();
	if(fvd != NULL)
	{
		for (int i=1; i <= NNodes(); i++)
		{
			GetNode(i).GetDrawTemp() += GetFieldVariableValue(*fvd, GetNodeLocPos2D(i), true);
			GetNode(i).GetDrawTempCnt()++;
		}
	}
}

template<class FiniteElement2DBase>
void TriangularGeneric<FiniteElement2DBase>::DrawElement()
{
	mbs->Graphics3D()->SetColor(col);
	mbs->Graphics3D()->SetDrawOutline(1); //turn on outline drawing

	int linemode = 1; //0=no lines, 1=outline+color, 2=outline, 3=elementline+color, 4=elementline

	HOTINTOptions::ViewingOptionsClass* vo = GetMBS()->GetOptions()->ViewingOptions();

	if (vo->FiniteElementsMeshShow() && vo->FiniteElementsContourActivate())
	{
		linemode = 2;
	}
	if (!vo->FiniteElementsMeshShow() && vo->FiniteElementsContourActivate())
	{
		linemode = 0;
	}

	int colormode = 0;
	const FieldVariableDescriptor * fv = GetMBS()->GetActualPostProcessingFieldVariable();
	if (fv != NULL && HasFieldVariable(*fv))
	{
		colormode = 1;
	}

	int res = GetMBS()->GetDrawResolution() - 1;
	if (colormode == 0 && NS() <= 3)
		res = 0;		// linear elements, not colored
	if (res < 0) res = 0;

	double tilex = pow(2.,res);

	double tiley = tilex;
	int tileyn = (int)tiley;

	double v = 0;

	TArray<Vector3D> points((int)(tilex+1)*(int)(tiley+1));
	TArray<Vector3D> normals((int)(tilex+1)*(int)(tiley+1));
	TArray<double> vals((int)(tilex+1)*(int)(tiley+1));
	points.SetLen(0);
	vals.SetLen(0);

	if (NNodes() == 3)
	{
		// plotting linear element interpolated - can be done quickly
		// add rectangular grid of points and values
		for (int i = 1; i <= 3; i++)
		{
			points.Add(ToP3D(GetPos2DD(GetNodeLocPos2D(i))));
			if (!GetMBS()->GetIOption(118)) //compute stress at every local position
			{
				if (colormode)
					v = GetFieldVariableValue(*GetMBS()->GetActualPostProcessingFieldVariable(), GetNodeLocPos2D(i), true);
			}
			else
			{
				v = GetNode(i).GetDrawTemp();
			}
			vals.Add(v);
			normals.Add(Vector3D(0,0,1));
		}
		mbs->Graphics3D()->DrawColorTrigs(points,vals, normals, colormode,linemode,1);
	}
}

template<class FiniteElement2DBase>
vtk::vtkElementInfo TriangularGeneric<FiniteElement2DBase>::GetVtkInfo() const
{
	vtk::vtkElementInfo vtk;
	vtk.nodes= nodes;
	vtk.cell_domain = materialnum;
	bool is_quadratic = (NNodes() == 6);

	if (is_quadratic)
	{
		vtk.cell_Type = vtk::VTK_QUADRATIC_TRIANGLE;
	}
	else
	{
		vtk.cell_Type = vtk::VTK_TRIANGLE;
	}
	return vtk;
}
