#pragma once
class GeomMesh3DInterface
{
public:
	//get number of triangle neighbouring at 'side'; side = 1,2,3; side 1= node 1 and 2, side 2=node 2 and 3, ...
	virtual int GetNeighbourTrig(int trig, int side, int& ntrig, int& nside) const = 0;
	//get all trigs (#: ntrigs) which are located around local vertex of trig; note that original trig is included in trigs
	virtual void GetTrigsAroundVertex(int trig, int vertex, IVector* trigs) const = 0; // (1-based query)	
	//! return, if local edge on trig is visible or not (effective means, its neigbouring trigs are not in the same plane) (1-based indexing!)
	virtual int IsVisibleTrigSide(int trig, int side) const = 0;
	//! return, if local vertex on trig is effective or not (effective means, its neigbouring trigs are not all in the same plane) (1-based indexing!)
	virtual int IsVisibleTrigPoint(int trig, int point) const = 0;
};