//#**************************************************************
//#
//# filename:             counter.h
//#
//# author:               PG
//#
//# generated:						september 2017;
//# description:          counts instances of an object class
//# remarks:						  class ExampleClass : public Counter<ExampleClass>
//#
//# Copyright (c) 2003-2017 Johannes Gerstmayr, Linz Center of Mechatronics GmbH, Austrian
//# Center of Competence in Mechatronics GmbH, Institute of Technical Mechanics at the 
//# Johannes Kepler Universitaet Linz, Austria. All rights reserved.
//#
//# This file is part of HotInt.
//# HotInt is free software: you can redistribute it and/or modify it under the terms of 
//# the HOTINT license. See folder 'licenses' for more details.
//#
//# bug reports are welcome!!!
//# WWW:		www.hotint.org
//# email:	bug_reports@hotint.org or support@hotint.org
//#***************************************************************************************

template<typename T>
class Counter {
public:
    Counter() { ++count; }
    Counter(const Counter&) { ++count; }
    ~Counter() { --count; }
 
    static int HowMany()
    { return count; }
 
private:
    static int count;
};
 
template<typename T>
int Counter<T>::count = 0;